Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Evaluators/IXCSEvaluator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Evaluators/IXCSEvaluator.cs	(revision 9089)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Evaluators/IXCSEvaluator.cs	(revision 9089)
@@ -0,0 +1,49 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Encodings.ConditionActionEncoding {
+  public interface IXCSEvaluator : IClassifierFitnessEvaluator {
+    IValueLookupParameter<DoubleValue> PredictionParameter { get; }
+    IValueLookupParameter<DoubleValue> ErrorParameter { get; }
+    IValueLookupParameter<IntValue> ExperienceParameter { get; }
+    IValueLookupParameter<IntValue> TimestampParameter { get; }
+    IValueLookupParameter<DoubleValue> AverageActionSetSizeParameter { get; }
+    ILookupParameter<DoubleValue> AccuracyParameter { get; }
+    ILookupParameter<DoubleValue> AccuracySumParameter { get; }
+    //used for macroclassifiers
+    IValueLookupParameter<IntValue> NumerosityParameter { get; }
+
+    //inital parameters
+    ILookupParameter<DoubleValue> InitialPredictionParameter { get; }
+    ILookupParameter<DoubleValue> InitialErrorParameter { get; }
+    ILookupParameter<DoubleValue> InitialFitnessParameter { get; }
+
+    ILookupParameter<PercentValue> AlphaParameter { get; }
+    ILookupParameter<PercentValue> BetaParameter { get; }
+    ILookupParameter<DoubleValue> PowerParameter { get; }
+    ILookupParameter<DoubleValue> ErrorZeroParameter { get; }
+    ILookupParameter<IntValue> ActualTimeParameter { get; }
+    ILookupParameter<IntValue> CurrentActionSetSizeParameter { get; }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Evaluators/XCSEvaluator.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Evaluators/XCSEvaluator.cs	(revision 9089)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Evaluators/XCSEvaluator.cs	(revision 9089)
@@ -0,0 +1,196 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.ConditionActionEncoding {
+  [Item("XCSEvaluator", "Evaluator tries to match condition and action of IMatching.")]
+  [StorableClass]
+  public class XCSEvaluator : SingleSuccessorOperator, IXCSEvaluator {
+    #region parameter properties
+    public IValueLookupParameter<DoubleValue> FitnessParameter {
+      get { return (IValueLookupParameter<DoubleValue>)Parameters["Fitness"]; }
+    }
+    public IValueLookupParameter<DoubleValue> CurrentPayoffParameter {
+      get { return (IValueLookupParameter<DoubleValue>)Parameters["CurrentPayoff"]; }
+    }
+    public IValueLookupParameter<DoubleValue> PredictionParameter {
+      get { return (IValueLookupParameter<DoubleValue>)Parameters["Prediction"]; }
+    }
+    public IValueLookupParameter<DoubleValue> ErrorParameter {
+      get { return (IValueLookupParameter<DoubleValue>)Parameters["Error"]; }
+    }
+    public IValueLookupParameter<IntValue> ExperienceParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["Experience"]; }
+    }
+    public IValueLookupParameter<IntValue> TimestampParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["Timestamp"]; }
+    }
+    public IValueLookupParameter<DoubleValue> AverageActionSetSizeParameter {
+      get { return (IValueLookupParameter<DoubleValue>)Parameters["AverageActionSetSize"]; }
+    }
+    public IValueLookupParameter<IntValue> NumerosityParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["Numerosity"]; }
+    }
+    public ILookupParameter<DoubleValue> InitialPredictionParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["InitialPrediction"]; }
+    }
+    public ILookupParameter<DoubleValue> InitialErrorParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["InitialError"]; }
+    }
+    public ILookupParameter<DoubleValue> InitialFitnessParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["InitialFitness"]; }
+    }
+    public ILookupParameter<PercentValue> BetaParameter {
+      get { return (ILookupParameter<PercentValue>)Parameters["Beta"]; }
+    }
+    public ILookupParameter<PercentValue> AlphaParameter {
+      get { return (ILookupParameter<PercentValue>)Parameters["Alpha"]; }
+    }
+    public ILookupParameter<DoubleValue> PowerParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["v"]; }
+    }
+    public ILookupParameter<IntValue> ActualTimeParameter {
+      get { return (ILookupParameter<IntValue>)Parameters["ActualTime"]; }
+    }
+    public ILookupParameter<IntValue> CurrentActionSetSizeParameter {
+      get { return (ILookupParameter<IntValue>)Parameters["CurrentActionSetSize"]; }
+    }
+    public ILookupParameter<DoubleValue> ErrorZeroParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["ErrorZero"]; }
+    }
+    public ILookupParameter<DoubleValue> AccuracyParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["Accuracy"]; }
+    }
+    public ILookupParameter<DoubleValue> AccuracySumParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["AccuracySum"]; }
+    }
+    #endregion
+
+    #region properties
+    private int Experience {
+      get { return ExperienceParameter.ActualValue.Value; }
+      set { ExperienceParameter.ActualValue.Value = value; }
+    }
+    private double Beta {
+      get { return BetaParameter.ActualValue.Value; }
+      set { BetaParameter.ActualValue.Value = value; }
+    }
+    private double Prediction {
+      get { return PredictionParameter.ActualValue.Value; }
+      set { PredictionParameter.ActualValue.Value = value; }
+    }
+    private double CurrentPayoff {
+      get { return CurrentPayoffParameter.ActualValue.Value; }
+      set { CurrentPayoffParameter.ActualValue.Value = value; }
+    }
+    private double Error {
+      get { return ErrorParameter.ActualValue.Value; }
+      set { ErrorParameter.ActualValue.Value = value; }
+    }
+    private double AverageActionSetSize {
+      get { return AverageActionSetSizeParameter.ActualValue.Value; }
+      set { AverageActionSetSizeParameter.ActualValue.Value = value; }
+    }
+    private int CurrentActionSetSize {
+      get { return CurrentActionSetSizeParameter.ActualValue.Value; }
+      set { CurrentActionSetSizeParameter.ActualValue.Value = value; }
+    }
+    private double Fitness {
+      get { return FitnessParameter.ActualValue.Value; }
+      set { FitnessParameter.ActualValue.Value = value; }
+    }
+    private double Accuracy {
+      get { return AccuracyParameter.ActualValue.Value; }
+    }
+    private double AccuracySum {
+      get { return AccuracySumParameter.ActualValue.Value; }
+    }
+    private int Numerosity {
+      get { return NumerosityParameter.ActualValue.Value; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    protected XCSEvaluator(bool deserializing) : base(deserializing) { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new XCSEvaluator(this, cloner);
+    }
+    protected XCSEvaluator(XCSEvaluator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public XCSEvaluator()
+      : base() {
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("Fitness", ""));
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("CurrentPayoff", ""));
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("Prediction", ""));
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("Error", ""));
+      Parameters.Add(new ValueLookupParameter<IntValue>("Experience", ""));
+      Parameters.Add(new ValueLookupParameter<IntValue>("Timestamp", ""));
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("AverageActionSetSize", ""));
+      Parameters.Add(new LookupParameter<DoubleValue>("Accuracy", ""));
+      Parameters.Add(new LookupParameter<DoubleValue>("AccuracySum", ""));
+      Parameters.Add(new ValueLookupParameter<IntValue>("Numerosity", ""));
+
+      Parameters.Add(new LookupParameter<DoubleValue>("InitialPrediction"));
+      Parameters.Add(new LookupParameter<DoubleValue>("InitialError"));
+      Parameters.Add(new LookupParameter<DoubleValue>("InitialFitness"));
+      Parameters.Add(new LookupParameter<IntValue>("ActualTime"));
+      Parameters.Add(new LookupParameter<PercentValue>("Beta"));
+      Parameters.Add(new LookupParameter<PercentValue>("Alpha"));
+      Parameters.Add(new LookupParameter<DoubleValue>("v"));
+      Parameters.Add(new LookupParameter<DoubleValue>("ErrorZero"));
+      Parameters.Add(new LookupParameter<IntValue>("CurrentActionSetSize"));
+    }
+
+    public override IOperation Apply() {
+      if (PredictionParameter.ActualValue == null) {
+        //the classifier has just been created
+        PredictionParameter.ActualValue = new DoubleValue(InitialPredictionParameter.ActualValue.Value);
+        ErrorParameter.ActualValue = new DoubleValue(InitialErrorParameter.ActualValue.Value);
+        FitnessParameter.ActualValue = new DoubleValue(InitialFitnessParameter.ActualValue.Value);
+        ExperienceParameter.ActualValue = new IntValue(0);
+        TimestampParameter.ActualValue = new IntValue(ActualTimeParameter.ActualValue.Value);
+        AverageActionSetSizeParameter.ActualValue = new DoubleValue(1);
+        NumerosityParameter.ActualValue = new IntValue(1);
+      } else {
+        Experience += 1;
+        if (Experience < (1 / Beta)) {
+          Prediction += (CurrentPayoff - Prediction) / Experience;
+          Error += (Math.Abs(CurrentPayoff - Prediction) - Error) / Experience;
+          AverageActionSetSize += (CurrentActionSetSize - AverageActionSetSize) / Experience;
+        } else {
+          Prediction += Beta * (CurrentPayoff - Prediction);
+          Error += Beta * (Math.Abs(CurrentPayoff - Prediction) - Error);
+          AverageActionSetSize += Beta * (CurrentActionSetSize - AverageActionSetSize);
+        }
+        Fitness += Beta * ((Accuracy * Numerosity) / AccuracySum - Fitness);
+      }
+      return base.Apply();
+    }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/HeuristicLab.Encodings.ConditionActionEncoding-3.3.csproj
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/HeuristicLab.Encodings.ConditionActionEncoding-3.3.csproj	(revision 9089)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/HeuristicLab.Encodings.ConditionActionEncoding-3.3.csproj	(revision 9089)
@@ -0,0 +1,121 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="4.0" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProductVersion>8.0.30703</ProductVersion>
+    <SchemaVersion>2.0</SchemaVersion>
+    <ProjectGuid>{422FB262-0845-4969-8D16-12F057AA90B1}</ProjectGuid>
+    <OutputType>Library</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>HeuristicLab.Encodings.ConditionActionEncoding</RootNamespace>
+    <AssemblyName>HeuristicLab.Encodings.ConditionActionEncoding-3.3</AssemblyName>
+    <TargetFrameworkVersion>v4.0</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup>
+    <SignAssembly>true</SignAssembly>
+  </PropertyGroup>
+  <PropertyGroup>
+    <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="HeuristicLab.Collections-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <Private>False</Private>
+    </Reference>
+    <Reference Include="HeuristicLab.Common-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <Private>False</Private>
+    </Reference>
+    <Reference Include="HeuristicLab.Core-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <Private>False</Private>
+    </Reference>
+    <Reference Include="HeuristicLab.Data-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <Private>False</Private>
+    </Reference>
+    <Reference Include="HeuristicLab.Operators-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <Private>False</Private>
+    </Reference>
+    <Reference Include="HeuristicLab.Optimization-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <Private>False</Private>
+    </Reference>
+    <Reference Include="HeuristicLab.Parameters-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <Private>False</Private>
+    </Reference>
+    <Reference Include="HeuristicLab.Persistence-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <Private>False</Private>
+    </Reference>
+    <Reference Include="HeuristicLab.PluginInfrastructure-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <Private>False</Private>
+    </Reference>
+    <Reference Include="HeuristicLab.Problems.DataAnalysis-3.4, Version=3.4.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
+    <Reference Include="HeuristicLab.Selection-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <Private>False</Private>
+    </Reference>
+    <Reference Include="System" />
+    <Reference Include="System.Core" />
+    <Reference Include="System.Xml.Linq" />
+    <Reference Include="System.Data.DataSetExtensions" />
+    <Reference Include="Microsoft.CSharp" />
+    <Reference Include="System.Data" />
+    <Reference Include="System.Xml" />
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="ActionSelection\ActionSelector.cs" />
+    <Compile Include="ActionSelection\OldActionSelector.cs" />
+    <Compile Include="ActionSelection\MaxValueActionSelector.cs" />
+    <Compile Include="ActionSelection\RandomActionSelector.cs" />
+    <Compile Include="Covering\CoveringOperator.cs" />
+    <Compile Include="Covering\ICovering.cs" />
+    <Compile Include="Covering\ICoveringSolutionCreator.cs" />
+    <Compile Include="Evaluators\XCSEvaluator.cs" />
+    <Compile Include="Evaluators\IConditionActionEvaluator.cs" />
+    <Compile Include="Evaluators\IXCSEvaluator.cs" />
+    <Compile Include="IClassifier.cs" />
+    <Compile Include="Interfaces\IConditionActionProblem.cs" />
+    <Compile Include="Interfaces\IConditionActionProblemData.cs" />
+    <Compile Include="Operator\CalculateAccuracy.cs" />
+    <Compile Include="Operator\CountNumberOfUniqueActions.cs" />
+    <Compile Include="Operator\PredictionArrayCalculator.cs" />
+    <Compile Include="Operator\MatchActionOperator.cs" />
+    <Compile Include="Operator\MatchConditionOperator.cs" />
+    <Compile Include="Operator\SumAccuracy.cs" />
+    <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="Plugin.cs" />
+    <Compile Include="Reinforcement\ActionExecuter.cs" />
+    <Compile Include="Reinforcement\IActionExecuter.cs" />
+    <Compile Include="Reinforcement\IClassifierFetcher.cs" />
+    <Compile Include="Selectors\IMatchSelector.cs" />
+    <Compile Include="Selectors\MatchSelector.cs" />
+    <None Include="Properties\AssemblyInfo.cs.frame" />
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="HeuristicLab.snk" />
+    <None Include="Plugin.cs.frame" />
+  </ItemGroup>
+  <ItemGroup />
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+</Project>
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/IClassifier.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/IClassifier.cs	(revision 9089)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/IClassifier.cs	(revision 9089)
@@ -0,0 +1,43 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Core;
+
+namespace HeuristicLab.Encodings.ConditionActionEncoding {
+  /// <summary>
+  /// IMatching is used in dictinoaries, therefore the methods "Equals" and "GetHashCode" have to be overriden
+  /// IEquatable<IMatching> should be implemented as well.
+  /// 
+  /// This also helps to implement macroclassifiers later on
+  /// </summary>
+  public interface IClassifier : IItem, IEquatable<IClassifier> {
+    IClassifier Condition { get; }
+    IClassifier Action { get; }
+    bool MatchCondition(IClassifier target);
+    bool MatchAction(IClassifier target);
+
+    //to use IMatching as key in a dictionary, Equals and GetHashCode have to be override. 
+    //Also IEquatable<Class> should be implemented.
+    bool Equals(object obj);
+    int GetHashCode();
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Interfaces/IConditionActionProblem.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Interfaces/IConditionActionProblem.cs	(revision 9089)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Interfaces/IConditionActionProblem.cs	(revision 9089)
@@ -0,0 +1,39 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Encodings.ConditionActionEncoding {
+  public interface IConditionActionProblem : IHeuristicOptimizationProblem {
+    IParameter ProblemDataParameter { get; }
+    IConditionActionProblemData ProblemData { get; }
+    IParameter ActionExecuterParameter { get; }
+    IActionExecuter ActionExecuter { get; }
+    IParameter ClassifierFetcherParameter { get; }
+    IClassifierFetcher ClassifierFetcher { get; }
+
+    IParameter PossibleActionsParameter { get; }
+    IItemSet<IClassifier> PossibleActions { get; }
+
+    new IXCSEvaluator Evaluator { get; }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Interfaces/IConditionActionProblemData.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Interfaces/IConditionActionProblemData.cs	(revision 9089)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Interfaces/IConditionActionProblemData.cs	(revision 9089)
@@ -0,0 +1,35 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Problems.DataAnalysis;
+
+namespace HeuristicLab.Encodings.ConditionActionEncoding {
+  public interface IConditionActionProblemData : INamedItem {
+    Dataset Dataset { get; }
+    ICheckedItemList<StringValue> ConditionVariables { get; }
+    ICheckedItemList<StringValue> ActionVariables { get; }
+    IEnumerable<string> AllowedConditionVariables { get; }
+    IEnumerable<string> AllowedActionVariables { get; }
+  }
+}
Index: /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Operator/CalculateAccuracy.cs
===================================================================
--- /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Operator/CalculateAccuracy.cs	(revision 9089)
+++ /branches/LearningClassifierSystems/HeuristicLab.Encodings.ConditionActionEncoding/3.3/Operator/CalculateAccuracy.cs	(revision 9089)
@@ -0,0 +1,89 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.ConditionActionEncoding {
+  [Item("CalculateAccuracy", "")]
+  [StorableClass]
+  public class CalculateAccuracy : SingleSuccessorOperator {
+    public ILookupParameter<PercentValue> AlphaParameter {
+      get { return (ILookupParameter<PercentValue>)Parameters["Alpha"]; }
+    }
+    public ILookupParameter<DoubleValue> ErrorParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["Error"]; }
+    }
+    public ILookupParameter<DoubleValue> ErrorZeroParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["ErrorZero"]; }
+    }
+    public ILookupParameter<DoubleValue> PowerParameter {
+      get { return (ILookupParameter<DoubleValue>)Parameters["v"]; }
+    }
+    public IValueLookupParameter<DoubleValue> AccuracyParameter {
+      get { return (IValueLookupParameter<DoubleValue>)Parameters["Accuracy"]; }
+    }
+
+    private double Error {
+      get { return ErrorParameter.ActualValue.Value; }
+    }
+    private double ErrorZero {
+      get { return ErrorZeroParameter.ActualValue.Value; }
+    }
+    private double Alpha {
+      get { return AlphaParameter.ActualValue.Value; }
+    }
+    private double Power {
+      get { return PowerParameter.ActualValue.Value; }
+    }
+
+    [StorableConstructor]
+    protected CalculateAccuracy(bool deserializing) : base(deserializing) { }
+    protected CalculateAccuracy(CalculateAccuracy original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public CalculateAccuracy()
+      : base() {
+      Parameters.Add(new LookupParameter<PercentValue>("Alpha"));
+      Parameters.Add(new LookupParameter<DoubleValue>("Error"));
+      Parameters.Add(new LookupParameter<DoubleValue>("ErrorZero"));
+      Parameters.Add(new LookupParameter<DoubleValue>("v"));
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("Accuracy"));
+    }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new CalculateAccuracy(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      if (Error < ErrorZero) {
+        AccuracyParameter.ActualValue = new DoubleValue(1);
+      } else {
+        AccuracyParameter.ActualValue = new DoubleValue(Alpha * Math.Pow(Error / ErrorZero, -Power));
+      }
+      return base.Apply();
+    }
+  }
+}
